[inherit('common', 'sys$library:pascal$lib_routines', 'sys$library:pascal$cli_routines')]
module cldsup;

function lowercase(s : pstr) : pstr;

var
   res : pstr;
   i : integer;

begin
   res := s;
   for i := 1 to length(res) do begin
      if ('A' <= s[i] ) and (s[i] <= 'Z') then begin
         res[i] := chr(ord(res[i]) + 32);
      end;
   end;
   lowercase := res;
end;

procedure cld_init(cmd : pstr; var tbl : integer);

var
   cmdlin : pstr;

begin
   lib$get_foreign(cmdlin.body, , cmdlin.length);
   cli$dcl_parse(cmd + ' ' + cmdlin, tbl);
end;

function cld_get_file : pstr;

var
   p1 : pstr;

begin
   cli$get_value('FILE', p1.body, p1.length);
   cld_get_file := p1;
end;

function cld_get_query : pstr;

var
   p1 : pstr;

begin
   cli$get_value('QUERY', p1.body, p1.length);
   cld_get_query := p1;
end;


function cld_get_host : pstr;

var
   host, log : pstr;

begin
   cli$get_value('HOST', host.body, host.length);
   if odd(lib$get_logical(host, log.body, log.length)) then begin
      cld_get_host := log;
   end else begin
      cld_get_host := host;
   end;
end;

function cld_get_port : integer;

var
   temp : pstr;
   port : integer;

begin
   cli$get_value('PORT', temp.body, temp.length);
   readv(temp, port);
   cld_get_port := port;
end;

function cld_get_library : pstr;

var
   library : pstr;

begin
   cli$get_value('LIBRARY', library.body, library.length);
   cld_get_library := lowercase(library);
end;

end.
